import es
from es import server_var
import playerlib
import keyvalues
import random
import os
import repeat
import gamethread

# all SZM server variables are declared here for convenience 
szm_version	  		= es.ServerVar("szm_version",			"3.0BETA", "Current SZM version.") 
szm		  		= es.ServerVar("szm",  				1, "Is SZM enabled or disabled.") 
	############################################################################
	############################Maps Settings###################################
	############################################################################
szm_dark_mod      		= es.ServerVar("szm_dark_mod",     		"b", "DarkMod can set Textures Ligth (A-Z).") 
szm_map_config	 		= es.ServerVar("szm_map_config", 		0, "Allow change SZM configs for each map.") 
szm_default_mapcycle   	 	= es.ServerVar("szm_default_mapcycle",  	0, "My default mapcycle.") 
szm_mapcycle	  		= es.ServerVar("szm_mapcycle",  		0, "Allow server run custom SZM mapcycle.") 
	############################################################################
	###########################Removes Settings#################################
	############################################################################
szm_remove_weapon_c4    	= es.ServerVar("szm_remove_weapon_c4",  	0, "Allow C4 in game?") 
szm_remove_hostage 		= es.ServerVar("szm_remove_hostage", 		0, "Allow Hostages in game?") 
szm_remove_time			= es.ServerVar("szm_remove_time",  		0, "Allow disable objectives and roundtime.") 
	############################################################################
	############################Sounds Settings#################################
	############################################################################
szm_zombie_ambient_sound	= es.ServerVar("szm_zombie_ambient_sound",  	0, "Enable zombie ambient sound.") 
szm_zombies_hurt_sounds		= es.ServerVar("szm_zombies_hurt_sounds",	0, "When zombies hurt can emit sounds.") 
szm_zombies_attack_sounds	= es.ServerVar("szm_zombies_attack_sounds",	0, "Zombies can emit sounds when hurt the humans.") 
szm_zombies_die_sounds		= es.ServerVar("szm_zombies_die_sounds",	0, "When zombies die can emit sounds.") 
	############################################################################
	##########################SZM Mods Settings#################################
	############################################################################
szm_he_damage			= es.ServerVar("szm_he_damage",		  	0, "Change the HeGrenade damage.") 
szm_he_radius			= es.ServerVar("szm_he_radius",			0, "Change the HeGrenade Radius.") 
szm_fire_grenades		= es.ServerVar("szm_fire_grenades",		0, "HeGrenades can burn zombies.") 
szm_fire_grenades_burn_time	= es.ServerVar("szm_fire_grenades_burn_time",	0, "Set burn time.") 
szm_infinite_he			= es.ServerVar("szm_infinite_he",  		0, "Allow Humans have infinite HeGrenades.") 
szm_infinite_he_type		= es.ServerVar("szm_infinite_he_type",		0, "Change the way Humans can recive HeGrenades.") 
szm_he_resuply_time		= es.ServerVar("szm_he_resuply_time",		0, "Change the time for resuply a Human with a HeGrenade.") 
szm_zombies_attract		= es.ServerVar("szm_zombies_attract",		0, "Enable Zombies Attract the Humans Mod.") 
szm_pjump			= es.ServerVar("szm_pjump",  			0, "Enable Power Jump for Zombies.") 
szm_zombies_recover_health	= es.ServerVar("szm_zombies_recover_health",  	0, "Enable Zombies regen Health.") 
szm_zombies_recover_health_type	= es.ServerVar("szm_zombies_recover_health_type", 0, "Change the way Zombies can recive Health.") 
szm_zombies_recover_health_time	= es.ServerVar("szm_zombies_recover_health_time", 0, "Change the Regeneation Time.") 
szm_zombies_recover_health_need	= es.ServerVar("szm_zombies_recover_health_need", 0, "Zombies start recive Health when have less than X.") 
szm_zombies_recover_health_win	= es.ServerVar("szm_zombies_recover_health_win",  0, "How much Hp Zombies can win per X seconds?") 
szm_jetpack			= es.ServerVar("szm_jetpack",			0, "Enable JetPack Mod.") 
szm_jetpack_t			= es.ServerVar("szm_jetpack_t",			0, "Zombies can use the JetPack?") 
szm_jetpack_ct			= es.ServerVar("szm_jetpack_ct",		0, "Humans can use the JetPack?") 
szm_infinite_ammo		= es.ServerVar("szm_infinite_ammo", 	 	0, "Allow Humans have infinite bullets.") 
szm_infinite_ammo_weapons	= es.ServerVar("szm_infinite_ammo_weapons",	0, "Choose the weapons can have infinite bullets.") 
szm_infection_mod		= es.ServerVar("szm_infection_mod",		0, "Enable Zombies can infect Humans with a Virus.") 
szm_infection_type		= es.ServerVar("szm_infection_type",		0, "Change the way infection mod works.") 
szm_infection_spawn_type	= es.ServerVar("szm_infection_spawn_type",  	0, "On Human infected can spawn in dead area or in zombie spawn point.") 
szm_only_hs			= es.ServerVar("szm_only_hs",			0, "Only Headshots can kill zombies?") 
szm_reviver_mod			= es.ServerVar("szm_reviver_mod",		0, "Allow zombies revive.") 
szm_reviver_mod_type		= es.ServerVar("szm_reviver_mod_type",		0, "Change the way Zombies can revive.") 
szm_kills_need_to_reviver	= es.ServerVar("szm_kills_need_to_reviver",	0, "Zombies will revive each X kills.") 
szm_teleport_mod		= es.ServerVar("szm_teleport_mod",  		0, "Allow Zombies teleport near Humans.") 
szm_hidden_mod			= es.ServerVar("szm_hidden_mod",		0, "Enable Hidden Mod.") 
szm_hidden_kills_for_team	= es.ServerVar("szm_hidden_kills_for_team",	0, "Amount of kills Humans win for kill the Hidden Zombie.") 
szm_hidden_ts_players_need	= es.ServerVar("szm_hidden_ts_players_need",	0, "Amount of Zombies for hidden mod can be used.") 
szm_hidden_kill_type		= es.ServerVar("szm_hidden_kill_type",  	0, "Change the way Hidden Zombie can kill others.") 
szm_hidden_health		= es.ServerVar("szm_hidden_health",		0, "Choose Hidden Zombie Health.") 
szm_hidden_speed		= es.ServerVar("szm_hidden_speed",		0, "Choose Hidden Zombie Speed.") 
szm_deathmatch_mod		= es.ServerVar("szm_deathmatch_mod",		0, "Allow respawn players after dead.") 
szm_deathmatch_mod_team_allow_respawn	= es.ServerVar("szm_deathmatch_mod_team_allow_respawn", 0, "Choose the teams allow to respawn (CT/T/ANY).") 
szm_deathmatch_mod_force_respawn	= es.ServerVar("szm_deathmatch_mod_force_respawn",	0, "Force respawn players after dead.") 
szm_crazy_zombies_mod		= es.ServerVar("szm_crazy_zombies_mod",		0, "Allow Leveling zombies.") 
szm_crazy_zombies_mod_type	= es.ServerVar("szm_crazy_zombies_mod_type",	0, "Change the way CrazyZombies Mod work.") 
szm_crazy_zombies_mod_leveling_type 	= es.ServerVar("szm_crazy_zombies_mod_leveling_type",  	0, "Change the way zombies can leveling.") 
szm_crazy_zombies_mod_health_to_add	= es.ServerVar("szm_crazy_zombies_mod_health_to_add",	0, "Health To Add for each level.") 
szm_crazy_zombies_mod_speed_to_add	= es.ServerVar("szm_crazy_zombies_mod_speed_to_add",	0, "Speed To Add for each level.") 
szm_crazy_zombies_mod_max_level		= es.ServerVar("szm_crazy_zombies_mod_max_level",	0, "Max level zombies can target.") 
szm_crazy_zombies_mod_begin_in	= es.ServerVar("szm_crazy_zombies_mod_begin_in", 0, "Set Default Level where zombies start.") 
szm_crazy_zombies_mod_msg_type	= es.ServerVar("szm_crazy_zombies_mod_msg_type", 0, "Change the way round msg are showed.") 
szm_crazy_zombies_mod_max_level_target	= es.ServerVar("szm_crazy_zombies_mod_max_level_target", 0, "Action for do after zombies reach max level.") 
szm_caos_mod			= es.ServerVar("szm_caos_mod",			0, "Enable Caos Mod (like zombiemod).") 
szm_caos_mod_time_to_begin	= es.ServerVar("szm_caos_mod_time_to_begin",  	0, "Time to begin caos mod after round start.") 
szm_cash_mod			= es.ServerVar("szm_cash_mod",			0, "Enable Cash Mod.") 
szm_cash_mod_type		= es.ServerVar("szm_cash_mod_type",		0, "Change the way Humans can win money.") 
szm_cash_mod_for_kill		= es.ServerVar("szm_cash_mod_$_for_kill",	0, "Amount of money humans win for kill a zombie.") 
szm_cash_mod_for_kill_hidden	= es.ServerVar("szm_cash_mod_$_for_kill_hidden", 0, "Amount of money player will win if kill the hidden zombie.") 
szm_cash_mod_for_spawn	= es.ServerVar("szm_cash_mod_$_for_spawn",	0, "Amount of money player will win when spawn.") 
szm_cash_mod_for_survive	= es.ServerVar("szm_cash_mod_$_for_survive",	0, "Amount of money player will if survive the round.") 
szm_extra_blood			= es.ServerVar("szm_extra_blood",		0, "Allow extra blood.") 
szm_vampire_mod			= es.ServerVar("szm_vampire_mod",		0, "Allow Zombies win Health when hurt a Human.") 
szm_vampire_mod_dmg		= es.ServerVar("szm_vampire_mod_dmg",		0, "% of Health to win over zombie attack damage.") 
szm_zombies_emit_sounds_mod	= es.ServerVar("szm_zombies_emit_sounds_mod",	0, "Allow zombies emit sounds.") 
szm_zombies_emit_sounds_mod_time	= es.ServerVar("szm_zombies_emit_sounds_mod_time", 0, "Set the time for each emit.") 
szm_zombies_emit_sounds_mod_min_zombies	= es.ServerVar("szm_zombies_emit_sounds_mod_min_zombies", 0, "Min Zombies alive for zombies can emit sounds.") 
szm_zombies_emit_sounds_mod_type	= es.ServerVar("szm_zombies_emit_sounds_mod_type", 0, "Change the way zombies can emit sounds.") 
szm_zombies_emit_sounds_mod_min_zombies_repeats	= es.ServerVar("szm_zombies_emit_sounds_mod_min_zombies_repeats", 0, "Min zombies alive for repeats works.") 
	############################################################################
	#############################Bots Settings##################################
	############################################################################
szm_bots_add_per_player		= es.ServerVar("szm_bots_add_per_player",	0, "Bots add per CT Player.") 
szm_default_bot_count		= es.ServerVar("szm_default_bot_count",		0, "Amount of bots in server when no humans in.") 
szm_high_bot_count		= es.ServerVar("szm_high_bot_count",		0, "Max amount of bots server can add.") 
	############################################################################
	###########################Server Settings##################################
	############################################################################
szm_auto_server_name		= es.ServerVar("szm_auto_server_name",		0, "Allow Change server name.") 
szm_stats			= es.ServerVar("szm_stats",			0, "Allow track human stats.") 
szm_humans_allow_join		= es.ServerVar("szm_humans_allow_join",		0, "Force humans join to (CT/T/ANY).") 
szm_restrict_nightvision_usage	= es.ServerVar("szm_restrict_nightvision_usage", 0, "Restrict NigthVision Usage.")
szm_anti_stuck			= es.ServerVar("szm_anti_stuck",		0, "Allow 'szmstuck' say.") 
	############################################################################
	#############################Shop Settings##################################
	############################################################################
szm_shop_props			= es.ServerVar("szm_shop_props",		0, "Enable SZM Props Shop.")
szm_shop_props_can_humans_buy	= es.ServerVar("szm_shop_props_can_humans_buy",	0, "Allow Humans can buy props.") 
szm_shop_props_can_zombies_buy	= es.ServerVar("szm_shop_props_can_zombies_buy", 0, "Allow Zombies can buy props.") 
	############################################################################
	##########################End Cfg Settings##################################
	############################################################################
_szm_tempuserid			= es.ServerVar("_szm_tempuserid",		0, "Temp userid SZM gets")

_szm_users_db = es.getAddonPath("szm") + "/db/"


info = es.AddonInfo() 
info.name     	= "Sn4k3 Zombie Mod" 
info.basename 	= "SZM"
info.version  	= str(szm_version)
info.url      	= "http://addons.eventscripts.com/addons/view/SZM" 
info.description = "The most complete ZombieMod"
info.author   	= "sn4k3"
#info.contact  	= "Tiago_caza@hotmail.com"
#info.tags	= "szm;zombie,zombies,infection"


_szm_opt = {}
_szm_opt['userids'] = {}
_szm_opt['handlemenu'] = {}
_szm_opt['data'] = {}
_szm_opt['data']['zombie_emit_sounds_repeat'] = 0
_szm_opt['data']['hidden_userid'] = 0
_szm_opt['data']['kills_to_revive'] = 0
_szm_opt['data']['teleport_announce'] = 0
_szm_opt['data']['crazy_zombies_mod_current_level'] = 0
_szm_opt['data']['crazy_zombies_mod_advert_check'] = 0
_szm_opt['data']['restricted_team'] = 0
_szm_opt['data']['restricted_nv'] = 0
_szm_opt['crazy_zombies'] = {}
_szm_opt['crazy_zombies']['count'] = 0
_szm_opt['zombies'] = {}
_szm_opt['zombies']['menus'] = {}
_szm_opt['zombies']['menus'][0] = "\n"
_szm_opt['zombies']['count'] = 0
_szm_opt['zombies']['menu_count'] = 0
_szm_opt['zombies']['menu_num_count'] = 0
_szm_opt['humans'] = {}
_szm_opt['humans']['count'] = 0
_szm_opt['humans']['menu_count'] = 0
_szm_opt['humans']['menu_num_count'] = 0
_szm_opt['humans']['menus'] = {}
_szm_opt['humans']['menus'][0] = "\n"
_szm_opt['zombies_emit'] = {}
_szm_opt['zombies_emit']['current'] = 0
_szm_opt['zombies_emit']['count'] = 0
_szm_opt['zombies_hurt'] = {}
_szm_opt['zombies_hurt']['count'] = 0
_szm_opt['zombies_attack'] = {}
_szm_opt['zombies_attack']['count'] = 0
_szm_opt['zombies_die'] = {}
_szm_opt['zombies_die']['count'] = 0
_szm_opt['PropsMenuCT'] = {}
_szm_opt['PropsMenuCT']['menus'] = {}
_szm_opt['PropsMenuCT']['menus'][0] = "\n"
_szm_opt['PropsMenuCT']['count'] = 0
_szm_opt['PropsMenuCT']['menu_count'] = 0
_szm_opt['PropsMenuCT']['menu_num_count'] = 0
_szm_opt['PropsMenuT'] = {}
_szm_opt['PropsMenuT']['menus'] = {}
_szm_opt['PropsMenuT']['menus'][0] = "\n"
_szm_opt['PropsMenuT']['count'] = 0
_szm_opt['PropsMenuT']['menu_count'] = 0
_szm_opt['PropsMenuT']['menu_num_count'] = 0

es.keygroupcreate("szm_users") 
szm_users = keyvalues.getKeyGroup("szm_users") 


def load():
	szm.set("1")
	szm_version.makepublic() 
	szm.makepublic() 
		
	es.mexec("szm/szm_server.cfg")
			
	es.delayed(1,"exec szm/szm_server_bot_settings")
	gamethread.delayed(2, szm_restrictions) 
	es.delayed(5,"es_xlightstyle 0 %s" % (szm_dark_mod))
	
	global _szm_opt
	_szm_opt['data']['crazy_zombies_mod_current_level'] = int(szm_crazy_zombies_mod_begin_in)
	
	repeat.create("_zombies_recover_repeat", "est_loop szm_tempuserid #t!d es_xdoblock szm/szm_mods/szm_zombie_recover_health")
		

	if int(szm_mapcycle): 
		es.set("mapcyclefile", "szmmapcycle.txt")
		
	es.doblock("corelib/noisy_on")
	
	if not es.exists("command", "szm_add_zombies_hurt_sound"):
		es.regcmd("szm_add_zombies_hurt_sound", "szm/szm_add_zombies_hurt_sound", "Add sounds for zombies emit on take damage")
	if not es.exists("command", "szm_add_zombies_attack_sound"):
		es.regcmd("szm_add_zombies_attack_sound", "szm/szm_add_zombies_attack_sound", "Add sounds for zombies emit on give damage")
	if not es.exists("command", "szm_add_zombies_die_sound"):
		es.regcmd("szm_add_zombies_die_sound", "szm/szm_add_zombies_die_sound", "Add sounds for zombies emit on die")
	if not es.exists("command", "szm_add_crazy_zombies_msg"):
		es.regcmd("szm_add_crazy_zombies_msg", "szm/szm_add_crazy_zombies_msg", "Add mensages to Crazy Zombies Mod")
	if not es.exists("command", "szm_add_zombies_emit_sound"):
		es.regcmd("szm_add_zombies_emit_sound", "szm/szm_add_zombies_emit_sound", "Add sounds to zombies emit")
	if not es.exists("command", "szm_add_humans_props"):
		es.regcmd("szm_add_humans_props", "szm/szm_add_humans_props", "Add models to humans prop spawn menu")
	if not es.exists("command", "szm_add_zombies_props"):
		es.regcmd("szm_add_zombies_props", "szm/szm_add_zombies_props", "Add models to zombies prop spawn menu")
	if not es.exists("command", "szm_add_zombie"):
		es.regcmd("szm_add_zombie", "szm/szm_add_zombie", "Add new zombies models")
	if not es.exists("command", "szm_add_human"):
		es.regcmd("szm_add_human", "szm/szm_add_human", "Add new humans models")
	if not es.exists("command", "szm_add_download_file"):
		es.regcmd("szm_add_download_file", "szm/szm_add_download_file", "Add files for downloads in a file")

	if str(szm_humans_allow_join) == "CT":
		es.server.cmd("est_RegClientCMD \"jointeam 2\" 0")
		_szm_opt['data']['restricted_team'] = "jointeam 2"
	elif str(szm_humans_allow_join) == "T":
		es.server.cmd("est_RegClientCMD \"jointeam 3\" 0")
		_szm_opt['data']['restricted_team'] = "jointeam 3"


	es.regclientcmd("+jetpack", "szm/szm_jetpack_use_cmd", "Use the JectPack (Fly)")
	es.regclientcmd("-jetpack", "szm/szm_jetpack_unuse_cmd", "Un-use the JectPack (Fly)")
	
	if not os.path.isdir(_szm_users_db):
		os.mkdir(_szm_users_db)
		szm_users.save(_szm_users_db + "szm_users.txt")
	elif os.path.isfile(_szm_users_db + "szm_users.txt"):
		szm_users.load(_szm_users_db + "szm_users.txt")
	else:
		szm_users.save(_szm_users_db + "szm_users.txt")
		
	if len(str(es.ServerVar('eventscripts_currentmap'))) > 1:
		es.server.cmd("bot_kill")
		szm_set_bot_quotas()
		if int(szm_remove_time):
			if 'cs_' == str(es.ServerVar('eventscripts_currentmap'))[0:3]:
				es.server.cmd("est_remove func_hostage_rescue")
			elif 'de_' == str(es.ServerVar('eventscripts_currentmap'))[0:3]:
				es.server.cmd("est_remove func_bomb_target")
		es.server.cmd("szm_add_download_file cfg/szm/szm_downloads.txt;exec szm/szm_models.cfg;exec szm/szm_sounds.cfg;exec szm/szm_shop.cfg")
		es.mexec("szm/szm_crazy_zombies_mod.cfg")
		
		if int(szm_restrict_nightvision_usage):
			es.regclientcmd("nightvision", "szm_nightvision_cmd", "Block NightVision usage!")
			_szm_opt['data']['restricted_nv'] = 1			

		
def unload():
	es.lightstyle(0,"g")
	szm.set("0")
	
	es.doblock("corelib/noisy_off")
	
	es.mexec("szm/szm_default_bot_settings.cfg")
	es.set("mapcyclefile", szm_default_mapcycle)
	
	if _szm_opt['data']['restricted_team']:
		es.server.cmd("est_UnRegClientCMD \"%s\"" % (_szm_opt['data']['restricted_team']))
	
	if _szm_opt['data']['restricted_nv']:
		es.unregclientcmd("nightvision")

	es.unregclientcmd("+jetpack")
	es.unregclientcmd("-jetpack")
	
	es.server.cmd("est_UnRestrictAll =2")
	if int(_szm_opt['data']['zombie_emit_sounds_repeat']):
		gamethread.cancelDelayed("zombies_emit_sounds_repeat")
	if int(_szm_opt['data']['hidden_userid']):
		gamethread.cancelDelayed("_slowbeat_repeat")
	repeat.delete("_zombies_recover_repeat")
	
	szm_users.save(_szm_users_db + "szm_users.txt")
	
	es.keygroupdelete("szm_users")
"""
def enable():
	szm.set("1")
	es.mexec("szm/szm_server.cfg")
	es.mexec("szm/szm_server_bot_settings.cfg")
	es.lightstyle(0, szm_dark_mod)
	
	if szm_remove_time:
		if "cs_" in server_var['eventscripts_currentmap']:
			es.server.cmd("est_remove func_hostage_rescue")
		elif "de_" in server_var['eventscripts_currentmap']:
			es.server.cmd("est_remove func_bomb_target")
	
	if szm_mapcycle:
		es.set("mapcyclefile", "szmmapcycle.txt")
		
	global szm_crazy_zombies_mod_current_level
	szm_crazy_zombies_mod_current_level = szm_crazy_zombies_mod_begin_in
	
	repeat.create("_zombies_recover_repeat", "est_loop szm_tempuserid #t!d es_xdoblock szm/szm_mods/szm_zombie_recover_health")
	
	es.set("eventscripts_noisy", "1")


def disable():
	es.lightstyle(0,"g")
	szm.set("0")
	
	es.mexec("szm/szm_default_bot_settings.cfg")
	

	if "cs_" in server_var['eventscripts_currentmap']:
		es.server.cmd("est_give #a func_hostage_rescue")
	elif "de_" in server_var['eventscripts_currentmap']:
		es.server.cmd("est_give #a func_bomb_target")


	es.set("mapcyclefile", szm_default_mapcycle)
		
	repeat.delete("_zombies_recover_repeat")
	
	global _szm_opt
	if _szm_opt['data']['restricted_team']:
		es.server.cmd("est_UnRegClientCMD %s" % (_szm_opt['data']['restricted_team']))

	if szm_humans_allow_join == "CT":
		es.server.cmd("est_RegClientCMD \"jointeam 2\" 0")
		_szm_opt['data']['restricted_team'] = "jointeam 2"
	elif szm_humans_allow_join == "T":
		es.server.cmd("est_RegClientCMD \"jointeam 3\" 0")
		_szm_opt['data']['restricted_team'] = "jointeam 3"
	
	if _szm_opt['data']['restricted_nv']:
		es.unregclientcmd("nightvision")
	if int(szm_restrict_nightvision_usage):
		es.regclientcmd("nightvision", "szm/szm_cmds/szm_nightvision_cmd", "Block NightVision usage!"
		_szm_opt['data']['restricted_nv'] = 1

	es.mexec("szm/szm_downloads.cfg")
	es.mexec("szm/szm_models.cfg")
	es.mexec("szm/szm_sounds.cfg")
	es.mexec("szm/szm_crazy_zombies_mod.cfg")
	es.mexec("szm/szm_shop.cfg")

"""
def es_map_start(event_var):
	es.stringtable("downloadables","sound/ambient/zombiemod/zombie_ambient.mp3")
	es.stringtable("downloadables","sound/sn4k3_scripts/szm/slowbeat.mp3")
	####es.stringtable("downloadables","sound/sn4k3_scripts/szm/fastbeat.mp3")
	
	es.delayed(1,"exec szm/szm_server_bot_settings;sv_skyname sky_borealis01")
	
	es.lightstyle(0, szm_dark_mod)
	
	if int(szm_map_config) and os.path.isfile("%s/cfg/szm/maps_configs/%s.cfg" % (es.ServerVar('eventscripts_gamedir'), event_var['mapname'])):
		es.mexec("szm/maps_configs/%s.cfg" % (event_var['mapname']))

	if int(szm_mapcycle):
		es.set("mapcyclefile", "szmmapcycle.txt")
		
	es.precachesound("sn4k3_scripts/szm/slowbeat.mp3")
	es.precachesound("ambient/zombiemod/zombie_ambient.mp3")
	es.precachesound("npc/manhack/mh_engine_loop2.wav")
	es.precachesound("npc/fast_zombie/fz_scream1.wav")

	szm_restrictions()
	
	global _szm_opt
	
	if not int(es.ServerVar('eventscripts_noisy')):
		es.doblock("corelib/noisy_on")

	_szm_opt['data']['hidden_userid'] = 0
	_szm_opt['data']['kills_to_revive'] = 0
	_szm_opt['data']['teleport_announce'] = 0
	_szm_opt['data']['crazy_zombies_mod_current_level'] = int(szm_crazy_zombies_mod_begin_in)
	_szm_opt['crazy_zombies'].clear()
	_szm_opt['crazy_zombies']['count'] = 0
	_szm_opt['zombies'].clear()
	_szm_opt['zombies']['menus'] = {}
	_szm_opt['zombies']['menus'][0] = "\n"
	_szm_opt['zombies']['count'] = 0
	_szm_opt['zombies']['menu_count'] = 0
	_szm_opt['zombies']['menu_num_count'] = 0
	_szm_opt['humans'].clear()
	_szm_opt['humans']['count'] = 0
	_szm_opt['humans']['menu_count'] = 0
	_szm_opt['humans']['menu_num_count'] = 0
	_szm_opt['humans']['menus'] = {}
	_szm_opt['humans']['menus'][0] = "\n"
	_szm_opt['zombies_emit'].clear()
	_szm_opt['zombies_emit']['current'] = 0
	_szm_opt['zombies_emit']['count'] = 0
	_szm_opt['zombies_hurt'].clear()
	_szm_opt['zombies_hurt']['count'] = 0
	_szm_opt['zombies_attack'].clear()
	_szm_opt['zombies_attack']['count'] = 0
	_szm_opt['zombies_die'].clear()
	_szm_opt['zombies_die']['count'] = 0
	_szm_opt['PropsMenuCT'].clear()
	_szm_opt['PropsMenuCT']['menus'] = {}
	_szm_opt['PropsMenuCT']['menus'][0] = "\n"
	_szm_opt['PropsMenuCT']['count'] = 0
	_szm_opt['PropsMenuCT']['menu_count'] = 0
	_szm_opt['PropsMenuCT']['menu_num_count'] = 0
	_szm_opt['PropsMenuT'].clear()
	_szm_opt['PropsMenuT']['menus'] = {}
	_szm_opt['PropsMenuT']['menus'][0] = "\n"
	_szm_opt['PropsMenuT']['count'] = 0
	_szm_opt['PropsMenuT']['menu_count'] = 0
	_szm_opt['PropsMenuT']['menu_num_count'] = 0
	_szm_opt['handlemenu'].clear()
	
	es.server.cmd("szm_add_download_file cfg/szm/szm_downloads.txt;exec szm/szm_models.cfg;exec szm/szm_sounds.cfg;exec szm/szm_shop.cfg")
	es.mexec("szm/szm_crazy_zombies_mod.cfg")

def est_map_end(event_var):
	if repeat.status("_zombies_recover_repeat") == 2:
		repeat.stop("_zombies_recover_repeat")
	if int(_szm_opt['data']['zombie_emit_sounds_repeat']):
		gamethread.cancelDelayed("zombies_emit_sounds_repeat")
		
	szm_users.save(_szm_users_db + "szm_users.txt")
	
def server_shutdown(event_var):
	szm_users.save(_szm_users_db + "szm_users.txt")

		
def player_activate(event_var):
	global _szm_opt
	if not _szm_opt['userids'].has_key(event_var['userid']):
		_szm_opt['userids'][event_var['userid']] = {}
	
	if not event_var['es_steamid'] == "BOT":
		gamethread.delayed(10, szm_delayed_funcs, (event_var['userid'], "welcome"))

		_szm_opt['userids'][event_var['userid']]['models_menu'] = 0
		_szm_opt['handlemenu'][event_var['userid']] = 0
		
		if not es.exists("key", "szm_users", event_var['es_steamid']):
			global szm_users
			szm_users[event_var['es_steamid']] = keyvalues.KeyValues(name=event_var['es_steamid']) 
			szm_users[event_var['es_steamid']]['Name'] = event_var['es_username']
			szm_users[event_var['es_steamid']]['Zombie Kills'] = 0
			szm_users[event_var['es_steamid']]['Zombie Deaths'] = 0
			szm_users[event_var['es_steamid']]['Zombie HeadShots'] = 0
			szm_users[event_var['es_steamid']]['Zombie Spawns'] = 0
			szm_users[event_var['es_steamid']]['Zombie Dmg'] = 0
			szm_users[event_var['es_steamid']]['Zombie Take Dmg'] = 0
			szm_users[event_var['es_steamid']]['Zombie Infected'] = 0
			szm_users[event_var['es_steamid']]['Humans Kills'] = 0
			szm_users[event_var['es_steamid']]['Humans Deaths'] = 0
			szm_users[event_var['es_steamid']]['Humans HeadShots'] = 0
			szm_users[event_var['es_steamid']]['Humans Spawns'] = 0
			szm_users[event_var['es_steamid']]['Humans Dmg'] = 0
			szm_users[event_var['es_steamid']]['Humans Take Dmg'] = 0
			szm_users[event_var['es_steamid']]['Humans Infected'] = 0
		

def es_client_command(event_var):
	szm_team = 0
	player = 0
	if "!szm" in event_var['command']:
		szm_team = es.getplayerteam(event_var['userid'])
		player = playerlib.getPlayer(event_var['userid'])
	if event_var['command'] == "!szmmodels":
		if int(szm_team) == 2:
			global _szm_opt
			_szm_opt['userids'][event_var['userid']]['models_menu'] = 0
			szm_models_menu(event_var['userid'], "zombie")
		elif int(szm_team) == 3:
			_szm_opt['userids'][event_var['userid']]['models_menu'] = 0
			szm_models_menu(event_var['userid'], "human")
	elif event_var['command'] == "!szmstuck":
		if not player.attributes['isdead']:
			es.server.cmd("est_PhysPush %s %s %s %s" % (event_var['userid'], random.randint(-1000, 1000), random.randint(-1000, 1000), random.randint(50, 1000)))
	elif event_var['command'] == "!szmshopprop":
		if int(szm_shop_props):
			player = playerlib.getPlayer(event_var['userid'])
			if not player.attributes['isdead']:
				_szm_opt['userids'][event_var['userid']]['shopprops_menu'] = 0
				if int(szm_team) == 2:
					if int(szm_shop_props_can_zombies_buy):
						szm_shop_props_menu(event_var['userid'], "zombie")
					else:
						es.tell(event_var['userid'], "\x04SZM:\x01 Zombies cant use\x03 Props\x01 Shops!")
				elif int(szm_team) == 3:
					if int(szm_shop_props_can_humans_buy):
						szm_shop_props_menu(event_var['userid'], "human")
					else:
						es.tell(event_var['userid'], "\x04SZM:\x01 Humans cant use\x03 Props\x01 Shops!")
			else:
				es.tell(event_var['userid'], "\x04SZM:\x01 You need be alive to\x03 Buy\x01!")
		else:
			es.tell(event_var['userid'], "\x04SZM:\x03 Props\x01 Shop is disable!")
			
	elif event_var['command'] == "menuselect":
		if int(_szm_opt['handlemenu'][event_var['userid']]):
			szm_team = es.getplayerteam(event_var['userid'])
		if int(_szm_opt['handlemenu'][event_var['userid']]) == 1:
			if int(szm_team) == 2:
				szm_zombies_handlemenu(event_var['userid'], event_var['commandstring'])
			elif int(szm_team) == 3:
				szm_humans_handlemenu(event_var['userid'], event_var['commandstring'])
		elif int(_szm_opt['handlemenu'][event_var['userid']]) == 2:
			if int(szm_team) == 2:
				szm_shop_zombies_props_handlemenu(event_var['userid'], event_var['commandstring'])
			elif int(szm_team) == 3:
				szm_shop_humans_props_handlemenu(event_var['userid'], event_var['commandstring'])

def player_disconnect(event_var):
	global _szm_opt
     		
	if not es.getplayercount(3) and int(szm_default_bot_count):
		es.set("bot_quota", szm_default_bot_count)
		
		_szm_opt['data']['crazy_zombies_mod_current_level'] = int(szm_crazy_zombies_mod_begin_in)
		
		if repeat.status("szm_zombies_recover_repeat") == 2:
			repeat.stop("szm_zombies_recover_repeat")

	if int(_szm_opt['data']['hidden_userid']) == int(event_var['userid']):
		_szm_opt['data']['hidden_userid'] = 0
		
	
def player_say(event_var):
	if event_var['text'][0:6] == "szmpag":
		es.server.cmd("est_Motd_W %s \"SZM Page\" 0 forums.mattie.info/cs/forums/viewtopic.php?t=6137" % (event_var['userid']))
	elif event_var['text'] == "szmhelp":
		es.menu(0, event_var['userid'], "SZM v%s <-> By sn4k3\n \nSZM Help Center\n \nSZM Say Comands (y)\n->1. szmmodel -> Re-Choose Your Model\n->2. szmstats -> See Your SZM Stats\n->3. szmhealth -> See Your Current Health\n->4. szmpag -> Go To SZM Forum Pag\n->5. szmammo -> Set player ammo to 1000\n->6. szmspawn -> Allow Player Respawn\n->7. szmaspawn -> Allow Admin Respawn Players\n->8. szmadmin -> Open admin menu\n->9. szmhelp -> Open Help Center\n \nSZM Client Console Commands\n->1. +jetpack -> Allow Player Fly (Create One bind eg-> bind v +jetpack)\n \n0 Cancel" % (szm_version))
	elif event_var['text'] == "szmhealth":
		player = playerlib.getPlayer(event_var['userid'])
		if not player.attributes['isdead']:
			es.server.cmd("est_Hsay %s SZM:\\nYour current health is: %s") % (userid, es.getplayerprop(userid, "CBasePlayer.m_iHealth"))
	elif event_var['text'] == "szmammo":
		player = playerlib.getPlayer(event_var['userid'])
		if not player.attributes['isdead']:
			es.server.cmd("est_SetAmmo %s 1 1000;est_SetAmmo %s 2 1000" % (event_var['userid'], event_var['userid']))
	elif event_var['text'] == "szmmodel":
		es.cexec(event_var['userid'], "!szmmodels")
	elif event_var['text'] == "szmspawn":
		szm_spawn_say(userid)
	elif event_var['text'] == "szmstuck":
		es.cexec(event_var['userid'], "!szmstuck")
	elif event_var['text'][0:7] == "szmprop":
		es.cexec(event_var['userid'], "!szmshopprop")
	elif event_var['text'][0:8] == "szmstats":
		if int(szm_stats):
			es.server.cmd("est_HSay #h SZM:\\nSay szmstats OR szmstats [player]\\nTo See my/other Player Stats")
			player = event_var['text'].replace("szmstats", "")
			msg = 0
			if not player:
				msg = "SZM v%s <-> By sn4k3\nMy SZM Stats\n " % (szm_version)
			else:
				player = event_var['text'].replace("szmstats ", "")
				userid = es.getuserid(player)
				if es.exists("userid", userid):
					if es.getplayersteamid(userid) == "BOT":
						es.tell(event_var['userid'], "\x04SZM:\x01 Invalid player. You cant see\x03 BOT\x01 Stats!")
					else:
						msg = "SZM v%s <-> By sn4k3\nSZM Stats for: %s\n " % (szm_version, es.getplayername(userid))
				else:
					es.tell(event_var['userid'], "\x04SZM:\x01 Invalid player\x03 name\x01/\x03userid\x01 with\x03 '%s'\x01 not exists!" % (player))

			if msg:
				msg += "\n(-CT- Human Status)\n->1. Zombies Killed: %s\n->2. Deaths: %s\n->3. HeadShots: %s\n->4. Spawns %s\n->5. Damage Given: %s\n->6. Damage Taken: %s\n->7. Infected: %s\n " % (szm_users[event_var['es_steamid']]['Humans Kills'], szm_users[event_var['es_steamid']]['Humans Deaths'], szm_users[event_var['es_steamid']]['Humans HeadShots'], szm_users[event_var['es_steamid']]['Humans Spawns'], szm_users[event_var['es_steamid']]['Humans Dmg'], szm_users[event_var['es_steamid']]['Humans Take Dmg'], szm_users[event_var['es_steamid']]['Humans Infected'])
				msg += "\n(-T- Zombie Status)\n->1. Humans Killed: %s\n->2. Deaths: %s\n->3. HeadShots Taken: %s\n->4. Spawns: %s\n->5. Damage Given: %s\n->6. Damage Taken: %s\n->7. Humans Infected: %s\n \n0. Cancel" % (szm_users[event_var['es_steamid']]['Zombie Kills'], szm_users[event_var['es_steamid']]['Zombie Deaths'], szm_users[event_var['es_steamid']]['Zombie HeadShots'], szm_users[event_var['es_steamid']]['Zombie Spawns'], szm_users[event_var['es_steamid']]['Zombie Dmg'], szm_users[event_var['es_steamid']]['Zombie Take Dmg'], szm_users[event_var['es_steamid']]['Zombie Infected'])
				es.menu(0, event_var['userid'], msg)
		else:
			es.tell(event_var['userid'], "\x04SZM:\x01 SZM Stats is currently\x03 disable\x01.")


def weapon_fire_on_empty(event_var):
	es.server.cmd("est_SetAmmo %s %s 1000;est_HSay %s SZM:\\nSay szmammo\\nTo get 1000 Bullets" % (event_var['userid'], event_var['weapon'], event_var['userid']))
	
def weapon_fire(event_var):
	if event_var['weapon'] == "hegrenade":
		if int(szm_fire_grenades):
			gamethread.delayed(0.1, szm_delayed_funcs, (event_var['userid'], "fire_he"))

		if int(szm_infinite_he) and int(szm_infinite_he_type) == 1:
				if _szm_opt['userids'].has_key(event_var['userid']) and int(_szm_opt['humans'][_szm_opt['userids'][event_var['userid']]['model_ct']]['IHG']):
					es.tell(event_var['userid'], "\x04SZM:\x01 You will be resupplied in\x03 %s\x01 seconds." % (szm_he_resuply_time))					
					gamethread.delayed(szm_he_resuply_time, szm_delayed_funcs, (event_var['userid'], "resupplie"))

	elif not event_var['weapon'] == "knife" and szm_infinite_ammo and event_var['weapon'] in str(szm_infinite_ammo_weapons):
		es.server.cmd("est_SetClipAmmo %s %s 10" % (event_var['userid'], event_var['weapon']))


def item_pickup(event_var):
	if event_var['item'] == "c4" and int(szm_remove_weapon_c4):
		es.remove("weapon_c4")
		

def player_spawn(event_var):
	global _szm_opt
	global szm_users
	if not _szm_opt['userids'].has_key(event_var['userid']):
		_szm_opt['userids'][event_var['userid']] = {}
		_szm_opt['userids'][event_var['userid']]['infected'] = 0
	if int(event_var['es_userteam']) == 2:
		if _szm_opt['userids'][event_var['userid']].has_key("model_t"):
			szm_give_models(event_var['userid'], "zombie")

		if not event_var['es_steamid'] == "BOT":
			if int(szm_zombie_ambient_sound):
				es.playsound(event_var['userid'], "ambient/zombiemod/zombie_ambient.mp3", 1.0)
			if not _szm_opt['userids'][event_var['userid']].has_key("model_t"):
				es.cexec(event_var['userid'], "!szmmodels")
			
			if int(szm_stats):
				szm_users[event_var['es_steamid']]['Zombie Spawns'] += 1
			
		else:
			if not _szm_opt['userids'][event_var['userid']].has_key("model_t"):
				szm_autorand_model(event_var['userid'], "zombie")
	elif int(event_var['es_userteam']) == 3:
		es.setplayerprop(event_var['userid'], "CCSPlayer.m_bNightVisionOn", 0)
		es.setplayerprop(event_var['userid'], "CCSPlayer.baseclass.m_iFOV", 90)
		if int(szm_cash_mod):
			if int(szm_cash_mod_type):
				es.setplayerprop(event_var['userid'], "CCSPlayer.m_iAccount", 16000)
			else:
				es.server.cmd("est_CashAdd %s %s" % (event_var['userid'], szm_cash_mod_for_spawn))

		if _szm_opt['userids'][event_var['userid']].has_key("model_ct"):
			szm_give_models(event_var['userid'], "human")

		if not event_var['es_steamid'] == "BOT":
			if not _szm_opt['userids'][event_var['userid']].has_key("model_ct"):
				es.cexec(event_var['userid'], "!szmmodels")
				
			if int(szm_zombie_ambient_sound):
				es.playsound(event_var['userid'], "ambient/zombiemod/zombie_ambient.mp3", 1.0)
			
			if int(szm_stats):
				szm_users[event_var['es_steamid']]['Humans Spawns'] += 1
			
		else:
			if not _szm_opt['userids'][event_var['userid']].has_key("model_ct"):
				szm_autorand_model(event_var['userid'], "human")

def round_start(event_var):
	global _szm_opt
	
	if int(szm_remove_time):
		if 'cs_' == str(es.ServerVar('eventscripts_currentmap'))[0:3]:
			es.server.cmd("est_remove func_hostage_rescue")
		elif 'de_' == str(es.ServerVar('eventscripts_currentmap'))[0:3]:
			es.server.cmd("est_remove func_bomb_target")
	
	szm_set_bot_quotas()

	if "cs_" == str(es.ServerVar('eventscripts_currentmap'))[0:3] and int(szm_remove_hostage):
		es.server.cmd("est_remove hostage_entity")
	
	
	if int(szm_caos_mod):
		gamethread.delayed(szm_caos_mod_time_to_begin, szm_delayed_funcs, (0, "caosmod"))
		es.msg("\x04SZM:\x01 Caos Mod will begin in:\x03 %s\x01 seconds!" % (szm_caos_mod_time_to_begin))

	if int(szm_crazy_zombies_mod) and _szm_opt['data']['crazy_zombies_mod_advert_check']:
		es.delayed(0.6, 'es_xmsg #multi #green SZM:#default %s' % (_szm_opt['data']['crazy_zombies_mod_advert_check']))
		
	es.server.cmd("est_SetCash #t 0")
	if int(szm_cash_mod) and not int(szm_cash_mod_type):
		es.server.cmd("est_SetCash #c 16000")

	if int(_szm_opt['data']['hidden_userid']):
		gamethread.cancelDelayed("_slowbeat_repeat")
		_szm_opt['data']['hidden_userid'] = 0
	if int(szm_hidden_mod) and int(es.getplayercount(2)) >= int(szm_hidden_ts_players_need):
		szm_hidden_mod_do()
		

	if int(szm_zombies_emit_sounds_mod):
		szm_zombies_emit_sounds_mod_check()

	rstatus = repeat.status("_zombies_recover_repeat")	
	if not int(szm_zombies_recover_health):
		if int(rstatus) == 2: 
			repeat.stop("_zombies_recover_repeat")
	else:
		if int(rstatus) == 1:
			repeat.start("_zombies_recover_repeat", szm_zombies_recover_health_time, 0)


def round_end(event_var):
	if int(event_var['winner']) > 1:
		global _szm_opt
		if int(szm_infection_mod) and not int(szm_caos_mod):
			gamethread.delayed(2.4, szm_infection_mod_reset)
			#szm_infection_mod_end()
		if int(event_var['winner']) == 3:
			es.delayed(1.1, "es_xmsg #multi #green SZM:#default Now The World Is Clean. The Zombie Race Has Been Destroyed.")
			if int(szm_crazy_zombies_mod) and int(szm_crazy_zombies_mod_leveling_type):
				_szm_opt['data']['crazy_zombies_mod_current_level'] -= 1
		elif int(event_var['winner']) == 2:
			es.delayed(1.1, "es_xmsg #multi #green SZM:#default Zombies Have Taken Ownership Of The World. The Human Race Has Been Destroyed.")
			if int(szm_crazy_zombies_mod) and int(szm_crazy_zombies_mod_type):
				_szm_opt['data']['crazy_zombies_mod_current_level'] += 1
			

		szm_crazy_zombies_mod_do()
	
		if int(szm_cash_mod) and int(szm_cash_mod_type) == 1:
			es.server.cmd('est_CashAdd #c!d %s' % (szm_cash_mod_for_survive))
		if int(szm_caos_mod):
			es.server.cmd("est_Team #t 3")
		

def player_hurt(event_var):
	global szm_users
	if int(event_var['es_userteam']) == 3:
		if not event_var['es_userteam'] == event_var['es_attackerteam'] and int(event_var['es_attackerteam']):
			if int(szm_zombies_attack_sounds) and _szm_opt['zombies_attack']['count']:
				es.emitsound("player", event_var['userid'], _szm_opt['zombies_attack'][random.randint(1, int(_szm_opt['zombies_attack']['count']))], 1.0, 0.5)

			
			if int(szm_stats):
				if not event_var['es_attackersteamid'] == "BOT":
					szm_users[event_var['es_attackersteamid']]['Zombie Dmg'] += int(event_var['dmg_health'])
				if not event_var['es_steamid'] == "BOT":
					szm_users[event_var['es_steamid']]['Humans Take Dmg'] += int(event_var['dmg_health'])
			

			if int(szm_infection_mod) and not int(szm_infection_type):
				es.msg("\x04SZM:\x01 Human player\x03 %s\x01 has been infected by\x03 %s\x01 zombie." % (event_var['es_username'], event_var['es_attackername']))
				szm_infection_mod_do(event_var['userid'], event_var['attacker'])

			if int(szm_vampire_mod):
				hp = int(event_var['dmg_health']) * int(szm_vampire_mod_dmg) / 100
				es.server.cmd("est_HealthAdd %s %s" % (event_var['attacker'], hp))
				es.tell(event_var['attacker'], "\x04SZM:\x01 You win\x03 %s\x01 health for attack\x03 %s\x01!" % (hp, event_var['es_username']))
	else:
		if not int(event_var['hitgroup']) == 1 and int(szm_only_hs):
			es.server.cmd("est_HealthAdd %s %s" % (event_var['userid'], event_var['dmg_health']))
		if not event_var['es_userteam'] == event_var['es_attackerteam'] and event_var['es_attackerteam']:
			if int(szm_extra_blood):
				es.server.cmd("es_fire %s env_blood Kill\
				es_give %s env_blood\
				es_fire %s env_blood addoutput \"spawnflags 13\"\
				es_fire %s env_blood addoutput \"amount 1000\"\
				es_fire %s env_blood addoutput \"color 1\"\
				es_fire %s env_blood EmitBlood" % (event_var['userid'], event_var['userid'], event_var['userid'], event_var['userid'], event_var['userid'], event_var['userid'], ))
		

			if event_var['weapon'] == "hegrenade" and int(szm_fire_grenades):
				if not int(szm_fire_grenades_burn_time):
					es.server.cmd("es_fire %s !self ignite" % (event_var['userid']))
				else:
					es.server.cmd("est_Burn %s %s" % (event_var['userid'], szm_fire_grenades_burn_time))
				
			if int(szm_zombies_hurt_sounds) and _szm_opt['zombies_hurt']['count']:
				es.emitsound("player", event_var['userid'], _szm_opt['zombies_hurt'][random.randint(1, int(_szm_opt['zombies_hurt']['count']))], 1.0, 0.5)

			
			if int(szm_stats):
				if not event_var['es_attackersteamid'] == "BOT":
					szm_users[event_var['es_attackersteamid']]['Humans Dmg'] += int(event_var['dmg_health'])
					if int(event_var['hitgroup']) == 1:
						szm_users[event_var['es_attackersteamid']]['Humans HeadShots'] += 1


				if not event_var['es_steamid'] == "BOT":
					szm_users[event_var['es_steamid']]['Zombie Take Dmg'] += int(event_var['dmg_health'])
					if int(event_var['hitgroup']) == 1:
						szm_users[event_var['es_steamid']]['Zombie HeadShots'] += 1
			
			
			if int(szm_zombies_attract):
				if _szm_opt['userids'].has_key(event_var['attacker']) and not _szm_opt['humans'][_szm_opt['userids'][event_var['attacker']]['model_ct']]['AA']:
					es.setplayerprop(event_var['attacker'], "CCSPlayer.baseclass.localdata.m_vecBaseVelocity", es.createvectorfrompoints(es.getplayerprop(event_var['attacker'], "CBaseEntity.m_vecOrigin")), es.getplayerprop(event_var['userid'], "CBaseEntity.m_vecOrigin"))
					es.emitsound("player", event_var['attacker'], "common/bass.wav", 0.5, 1.0)

def player_death(event_var):     
	global szm_users
	pcountaliveT = es.getlivingplayercount(2)
	pcountaliveCT = es.getlivingplayercount(3)
	global _szm_opt
	if int(event_var['es_userteam']) == 2:
		if int(szm_hidden_mod):
			if int(_szm_opt['data']['hidden_userid']) == int(event_var['userid']):
				if int(szm_teleport_mod):
					szm_teleport_mod.set(0)
					es.delayed(1, "szm_teleport_mod 1")
				if int(szm_teleport_mod):
					szm_reviver_mod.set(0)
					es.delayed(1, "szm_reviver_mod 1")
						
				es.server.queuecmd("est_KillAdd #c!d %s" % (szm_hidden_kills_for_team))
				if int(szm_cash_mod) and int(szm_cash_mod_type) == 1:
					es.server.queuecmd("est_CashAdd %s %s" % (event_var['attacker'], szm_cash_mod_for_kill_hidden))
				
				if event_var['es_attackername']:
					es.msg("\x04SZM:\x01 Hidden zombie killed by:\x03 %s\x01!" % (event_var['es_attackername']))
				else:
					es.msg("\x04SZM:\x01 Hidden zombie commit a\x03 suicide\x01!")
				_szm_opt['data']['hidden_userid'] = 0
					
				if int(pcountaliveT):
					if int(szm_hidden_kill_type):
						if int(event_var['attacker']):
							es.server.queuecmd("est_KillAdd %s %s" % (event_var['attacker'], pcountaliveT))
							szm_users[event_var['es_attackersteamid']]['Humans Kills'] += int(pcountaliveT)
						es.delayed(0.5, "est_rocket #t!d")
					else:
						es.server.queuecmd("est_loop _szm_tempuserid #t!d \"est_damage %s %s 10000\" " % (event_var['attacker'], _szm_tempuserid))
			elif int(pcountaliveT) == 1 and int(_szm_opt['data']['hidden_userid']):
				es.server.cmd("es_give %s weapon_knife;est_give #c!d weapon_hegrenade;est_hsay #h SZM Hidden Mod:\\nThe hidden zombie have now one 'Knife'\\nUse the fire grenades to stop him and listen the heartbeat!\\nBe careful!" % (_szm_opt['data']['hidden_userid']))
					
		if not event_var['es_userteam'] == event_var['es_attackerteam'] and int(event_var['es_attackerteam']):
			if int(szm_zombies_die_sounds) and _szm_opt['zombies_die']['count']:
				es.emitsound("player", event_var['userid'], _szm_opt['zombies_die'][random.randint(1, int(_szm_opt['zombies_die']['count']))], 1.0, 0.5)

				if int(szm_reviver_mod) and int(pcountaliveT):
						_szm_opt['data']['kills_to_revive'] += 1
						if int(_szm_opt['data']['kills_to_revive']) == int(szm_kills_need_to_reviver):
							_szm_opt['data']['kills_to_revive'] = 0
							if int(szm_reviver_mod_type):
								szm_reviver_mod_do(event_var['attacker'])

				if int(szm_teleport_mod) and int(pcountaliveCT) == 1 and int(pcountaliveT):
					gamethread.delayed(1, szm_delayed_funcs, (0, "teleport1", event_var['attacker']))

					es.msg("\x04SZM:\x01 One Zombie is teleporting near\x03 %s\x01!" % (event_var['es_attackername']))
					if int(_szm_opt['data']['teleport_announce']):
						_szm_opt['data']['teleport_announce'] = 0
						es.msg("\x04SZM:\x01 Be carefull, Zombies have begun\x03 teleporting\x01 too\x03 %s\x01!" % (event_var['es_attackername'])) 



				if int(szm_deathmatch_mod) and int(szm_deathmatch_mod_force_respawn) == 1 and not int(szm_deathmatch_mod_team_allow_respawn) == 2:
					es.server.cmd("est_spawn %s" % (event_var['userid']))

				if int(szm_cash_mod) and int(szm_cash_mod_type) == 1:
					es.server.cmd("est_CashAdd %s %s" % (event_var['attacker'], szm_cash_mod_for_kill))

				
				if int(szm_stats):
					if not event_var['es_steamid'] == "BOT":
						szm_users[event_var['es_steamid']]['Zombie Deaths'] += 1
	

					if not event_var['es_attackersteamid'] == "BOT":
						szm_users[event_var['es_attackersteamid']]['Humans Kills'] += 1
				
	else:
		if not event_var['es_userteam'] == event_var['es_attackerteam'] and int(event_var['es_attackerteam']):
			if int(szm_reviver_mod) and int(pcountaliveT) and not int(szm_reviver_mod_type) == 1:
					szm_reviver_mod_do(event_var['attacker'])

			if int(szm_infection_mod) and int(szm_infection_type) == 1 and int(pcountaliveCT):
				szm_infection_mod_do(event_var['userid'], event_var['attacker'])

			if int(szm_deathmatch_mod) and int(szm_deathmatch_mod_force_respawn) and int(szm_deathmatch_mod_team_allow_respawn) < 3:
				es.server.cmd("est_spawn %s" % (event_var['userid']))

			
			if int(szm_stats):
				if not event_var['es_steamid'] == "BOT":
					szm_users[event_var['es_steamid']]['Humans Deaths'] += 1


				if not event_var['es_attackersteamid'] == "BOT":
					szm_users[event_var['es_attackersteamid']]['Zombie Kills'] += 1
			

	if not event_var['es_steamid'] == "BOT":
		gamethread.delayed(1, szm_delayed_funcs, (event_var['userid'], "szmmodeldie"))

def player_jump(event_var):
	if es.getplayerteam(event_var['userid']) == 2 and int(szm_pjump) and _szm_opt['userids'][event_var['userid']].has_key("model_t"):
		if _szm_opt['zombies'][_szm_opt['userids'][event_var['userid']]['model_t']]['PJ']:
			es.server.cmd("est_SetGravity %s 0.5" % (event_var['userid']))
			es.delayed(0.7, "est_SetGravity %s 1.0" % (event_var['userid']))
			
		
#def szm_db_check():

	
def szm_restrictions():
	es.set("est_enable_weapon_restrictions", 1)
	es.server.cmd("est_RestrictAll =2;est_UnRestrict =2 weapon_knife;est_UnRestrict =2 weapon_c4")
		
def szm_set_bot_quotas():
	count = 0
	
	if int(szm_bots_add_per_player):
		if not int(szm_caos_mod):
			es.set("bot_join_team", "T")
			count = es.getplayercount(3)
		else:
			es.set("bot_join_team", "CT")
			es.server.cmd("est_PlayerCount _szm_tempuserid #h")
			count = int(_szm_tempuserid)

		if int(count):
			count *= int(szm_bots_add_per_player)
			if int(count) >= int(szm_high_bot_count):
				es.set("bot_quota", szm_high_bot_count)
			else:
				es.set("bot_quota", count)
		else:
			global _szm_opt
			_szm_opt['data']['crazy_zombies_mod_advert_check'] = 0
			es.set("bot_quota", szm_default_bot_count)
			
def szm_zombies_emit_sounds_mod_check():
		if es.getplayercount(3):
			global _szm_opt
			if not int(_szm_opt['data']['zombie_emit_sounds_repeat']):
				_szm_opt['data']['zombie_emit_sounds_repeat'] = 1
				gamethread.delayedname(szm_zombies_emit_sounds_mod_time, "zombies_emit_sounds_repeat", szm_zombies_emit_sounds_mod_play, ())
		elif int(_szm_opt['data']['zombie_emit_sounds_repeat']):
			_szm_opt['data']['zombie_emit_sounds_repeat'] = 0
			gamethread.cancelDelayed("zombies_emit_sounds_repeat")
				
def szm_delayed_funcs(userid, funcs, attacker = 0, extraparm = 0):
	if int(userid) and not es.exists("userid", userid):
		return '0'
	if int(attacker) and not es.exists("userid", attacker):
		return '0'
	
	if funcs == "resupplie":
		player = playerlib.getPlayer(userid)
		if not player.attributes['isdead'] and not es.getplayerprop(userid, "CBasePlayer.localdata.m_iAmmo.011"):
			es.server.cmd("es_give %s weapon_hegrenade" % (userid))
			es.tell(userid, "\x04SZM:\x01 You have been\x03 resupplied\x01 with a hegrenade!")
	elif funcs == "caosmod":
		es.server.cmd("bot_all_weapons;est_RandPlayer _szm_tempuserid #c!d")
		es.server.cmd("est_Team %s 2"  % (_szm_tempuserid))
		global _szm_opt
		if _szm_opt['userids'][str(_szm_tempuserid)].has_key("model_t"):
			del _szm_opt['userids'][str(_szm_tempuserid)]['model_t']
		szm_autorand_model(str(_szm_tempuserid), "zombie")
		es.emitsound("player", str(_szm_tempuserid), "npc/fast_zombie/fz_scream1.wav", 1.0, 0.5)
		es.msg("\x04SZM:\x01 Caos Mod\x01 began\x01!")
	elif funcs == "welcome":
		es.tell(userid, "\x04SZM:\x01 Counter-strike Source\x03 Zombie Mod\x01, version: \x03%s\n\x04SZM:\x01 Written By:\x03 sn4k3\x01 AKA\x03 Tiago Conceicao\n\x04Visit:\x01 http://addons.eventscripts.com/addons/view/SZM\n" % (szm_version))
	elif funcs == "szmmodeldie":
		es.tell(userid, "\x04SZM:\x01 Say '\x03szmmodel\x01' to change your character.")
	elif funcs == "teleport1":
		es.server.cmd("est_RandPlayer _szm_tempuserid #t!d")
		es.emitsound("player", _szm_tempuserid, "ambient/machines/teleport3.wav", 1.0, 0.5)
		gamethread.delayed(3, szm_delayed_funcs, (_szm_tempuserid, "teleport4", attacker))
	elif funcs == "teleport4":	
		player = playerlib.getPlayer(userid)
		if not player.attributes['isdead']:
			es.emitsound("player", userid, "ambient/levels/labs/electric_explosion4.wav", 1.0, 0.5)
			es.server.cmd("est_Teleport %s %s" % (userid, attacker))
			es.server.cmd("est_PhysPush %s %s %s %s" % (userid, random.randint(-1000, 1000), random.randint(-1000, 1000), random.randint(50, 1000)))
	elif funcs == "infection_respawn":
		szm_autorand_model(userid, "zombie")
		es.server.queuecmd("est_spawn %s" % (userid))
		if not int(szm_infection_spawn_type):
			es.setpos(userid, extraparm)
	elif funcs == "fire_he":
		es.server.cmd("es_fire %s hegrenade_projectile ignite" % (userid))
		i = es.getentityindex("hegrenade_projectile")
		if int(i):
			if int(szm_he_damage):
				es.setindexprop(i, "CBaseCSGrenadeProjectile.baseclass.m_flDamage", szm_he_damage)
			if int(szm_he_radius):
				es.setindexprop(i, "CBaseCSGrenadeProjectile.baseclass.m_DmgRadius", szm_he_radius)
				
			
#############################################################################################################################
         ##########################################       SZM Mods           #######################################
#############################################################################################################################
def szm_zombie_recover_health(userid):
	if int(szm_zombies_recover_health_type):
		if int(es.getplayerprop(userid, "CBasePlayer.m_iHealth")) < int(szm_zombies_recover_health_need):
			szm_zombie_recover_health_add(userid)
	else:
		szm_zombie_recover_health_add(userid)


def szm_zombie_recover_health_add(userid):
	health = _szm_opt['zombies'][_szm_opt['userids'][_szm_tempuserid]['model_t']]['Health']
	phealth = es.getplayerprop(userid, "CBasePlayer.m_iHealth")
	if int(phealth) < int(health):
		health += int(szm_zombies_recover_health_win)
		if int(phealth) >= int(health):
			es.setplayerprop(userid, "CBasePlayer.m_iHealth", phealth)
		else:
			es.setplayerprop(userid, "CBasePlayer.m_iHealth", health)


def szm_infection_mod_do(userid, attacker):
	global szm_users
	global _szm_opt
	if int(szm_stats):
		useridsteamid = es.getplayersteamid(userid)
		attackersteamid = es.getplayersteamid(attacker)
		if not useridsteamid == "BOT":
			szm_users[useridsteamid]['Humans Infected'] += 1

		if not attackersteamid == "BOT":
			szm_users[attackersteamid]['Zombie Infected'] += 1

	count = es.getlivingplayercount(3)
	if not int(szm_infection_type):
		count -= 1
	if not int(count):
		es.server.queuecmd("est_God #a 1")
		if not int(szm_infection_type):
			szm_infection_mod_end()
		else:
			return '0'
			
	if _szm_opt['userids'][userid].has_key("model_t"):
		del _szm_opt['userids'][userid]['model_t']

	es.server.cmd("est_Team %s 2" % (userid))
	_szm_opt['userids'][userid]['infected'] = 1
	es.emitsound("player", userid, "npc/fast_zombie/fz_scream1.wav", 1.0, 0.5)
		
	if not int(szm_infection_type):
		es.server.cmd("est_KillAdd %s 1" % (attacker))
		szm_autorand_model(userid, "zombie")
	else:
		_szm_opt['userids'][userid]['model_t'] = 0
		if int(szm_infection_spawn_type):
			gamethread.delayed(0.1, szm_delayed_funcs, (userid, "infection_respawn"))
		else:
			gamethread.delayed(0.1, szm_delayed_funcs, (userid, "infection_respawn", 0, es.getplayerlocation(userid)))
	es.tell(userid, "\x04SZM:\x01 You are\x03 infected\x01 with a zombie virus. You are now a \x03Zombie\x01!")


def szm_infection_mod_end():
	es.server.queuecmd("est_endround 0 9")
	es.delayed(4, "es_xset sv_cheats 1;endround;es_xset sv_cheats 0")

def szm_infection_mod_reset():
	global _szm_opt
	players = playerlib.getUseridList("#all") 
	for i in players:
		if int(_szm_opt['userids'][str(i)]['infected']):
			es.server.queuecmd("est_Team %s 3" % (i))
			_szm_opt['userids'][str(i)]['infected'] = 0


def szm_reviver_mod_do(attacker):
	if not int(es.getplayercount(2)) == int(es.getlivingplayercount(2)):
		es.server.cmd("est_RandPlayer _szm_tempuserid #t!l")
		es.server.cmd("est_Spawn %s" % (_szm_tempuserid))
		es.msg("\x04SZM:\x01 Zombie\x03 %s\x01 has been revived." % (es.getplayername(_szm_tempuserid)))
		es.tell(attacker, "\x04SZM:\x01 You have been\x03 revived\x01 a zombie!")

def szm_hidden_mod_do():
	es.server.cmd("est_RandPlayer _szm_tempuserid #t!d")

	if int(szm_hidden_health):
		es.setplayerprop(_szm_tempuserid, "CBasePlayer.m_iHealth", szm_hidden_health)
	if float(szm_hidden_speed):
		es.setplayerprop(_szm_tempuserid, "CBasePlayer.localdata.m_flLaggedMovementValue", szm_hidden_speed)
		
	es.setplayerprop(_szm_tempuserid, "CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_fEffects", 32)
	
	global _szm_opt
	_szm_opt['data']['hidden_userid'] = int(_szm_tempuserid)
	gamethread.delayedname(1, "_slowbeat_repeat", szm_slowbeat_repeat)
	es.delayed(1, "es_xmsg #multi #green SZM:#default Hidden Zombie:#lightgreen %s#default. Kill him and win the round!;est_StripPlayer %s" % (es.getplayername(_szm_tempuserid), _szm_tempuserid))

def szm_slowbeat_repeat():
	if int(_szm_opt['data']['hidden_userid']):
		es.emitsound("player", _szm_opt['data']['hidden_userid'], "sn4k3_scripts/szm/slowbeat.mp3", 1.0, 0.5)
		gamethread.delayedname(1, "_slowbeat_repeat", szm_slowbeat_repeat)


def szm_crazy_zombies_mod_do():
	global _szm_opt
	if not int(szm_crazy_zombies_mod_type):
		_szm_opt['data']['crazy_zombies_mod_current_level'] = random.randint(1, int(szm_crazy_zombies_mod_max_level))
	else:

		if not int(_szm_opt['data']['crazy_zombies_mod_current_level']):
			_szm_opt['data']['crazy_zombies_mod_current_level'] = 1
		
		if int(_szm_opt['data']['crazy_zombies_mod_current_level']) > int(szm_crazy_zombies_mod_max_level):
			if int(szm_crazy_zombies_mod_max_level_target) == 1:
				_szm_opt['data']['crazy_zombies_mod_current_level'] = 1
			elif int(szm_crazy_zombies_mod_max_level_target) == 2:
				_szm_opt['data']['crazy_zombies_mod_current_level'] = int(szm_crazy_zombies_mod_begin_in)
			elif int(szm_crazy_zombies_mod_max_level_target) == 3:
				es.msg("\x04SZM:\x03 Zombies\x01 Has\x04 Destroyed\x01 All\x03 Humans\x01.")
				es.msg("\x04SZM:\x03 Zombies\x01 Have Been\x04 Taken\x01 The\x04 Control\x01 Of That\x03 World\x01.")

				es.server.cmd("est_randplayer _szm_tempuserid #a;es_give %s \"game_end\";es_fire %s \"game_end EndGame\" " % (_szm_tempuserid, _szm_tempuserid))


	advert = 0
	count = int(_szm_opt['crazy_zombies']['count'])
	if int(szm_crazy_zombies_mod_msg_type):
		advert = _szm_opt['crazy_zombies'][random.randint(1, int(count))]
	else:
		if int(_szm_opt['data']['crazy_zombies_mod_current_level']) > int(count):
			advert = "No#lightgreen mensage#default for this#green level"
		else:
			advert = _szm_opt['crazy_zombies'][_szm_opt['data']['crazy_zombies_mod_current_level']]
	_szm_opt['data']['crazy_zombies_mod_advert_check'] = "Crazy Zombies Mod ->#lightgreen Level#default [#green%s#default/#green%s#default]: %s" % (_szm_opt['data']['crazy_zombies_mod_current_level'], szm_crazy_zombies_mod_max_level, advert)


def szm_zombies_emit_sounds_mod_play():
	if int(es.getlivingplayercount(2)) >= int(szm_zombies_emit_sounds_mod_min_zombies):
		es.server.cmd("est_randplayer _szm_tempuserid #t!d")
		if int(_szm_tempuserid):
			global _szm_opt
			if not int(szm_zombies_emit_sounds_mod_type):
				_szm_opt['zombies_emit']['current'] = random.randint(1, int(_szm_opt['zombies_emit']['count']))
			else:
				if _szm_opt['zombies_emit']['current'] == int(_szm_opt['zombies_emit']['count']):
					_szm_opt['zombies_emit']['current'] = 0
				_szm_opt['zombies_emit']['current'] += 1
		
			es.emitsound("player", _szm_tempuserid, _szm_opt['zombies_emit'][_szm_opt['zombies_emit']['current']]['sound'], 1.0, _szm_opt['zombies_emit'][_szm_opt['zombies_emit']['current']]['attenuation'])
			i = int(_szm_opt['zombies_emit'][_szm_opt['zombies_emit']['current']]['repeats'])
			if int(i):
				while int(i):
					es.server.cmd("est_randplayer _szm_tempuserid #t!d")
					es.emitsound("player", _szm_tempuserid, _szm_opt['zombies_emit'][_szm_opt['zombies_emit']['current']]['sound'], 1.0, _szm_opt['zombies_emit'][_szm_opt['zombies_emit']['current']]['attenuation'])
					i -= 1
		if int(szm_zombies_emit_sounds_mod):
			gamethread.delayedname(szm_zombies_emit_sounds_mod_time, "zombies_emit_sounds_repeat", szm_zombies_emit_sounds_mod_play)


#############################################################################################################################
         ##########################################       SZM CMDS           #######################################
#############################################################################################################################

def szm_add_zombies_hurt_sound():
	argv1 = es.getargv(1)
	if "." in argv1:
		global _szm_opt
		_szm_opt['zombies_hurt']['count'] += 1
		_szm_opt['zombies_hurt'][_szm_opt['zombies_hurt']['count']] = argv1

		es.precachesound(argv1)
		if es.getargv(2):
			es.stringtable("downloadables","sound/%s" % (argv1))
	else:
		es.dbgmsg(0, "Syntax: szm_add_zombies_hurt_sound <soundfile.wav|mp3> <Download (0 = No | 1 = Yes)>")

def szm_add_zombies_attack_sound():
	argv1 = es.getargv(1)
	if "." in argv1:
		global _szm_opt
		_szm_opt['zombies_attack']['count'] += 1
		_szm_opt['zombies_attack'][_szm_opt['zombies_attack']['count']] = argv1

		es.precachesound(argv1)
		if es.getargv(2):
			es.stringtable("downloadables","sound/%s" % (argv1))
	else:
		es.dbgmsg(0, "Syntax: szm_add_zombies_attack_sound <soundfile.wav|mp3> <Download (0 = No | 1 = Yes)>")


def szm_add_zombies_die_sound():
	argv1 = es.getargv(1)
	if "." in argv1:
		global _szm_opt
		_szm_opt['zombies_die']['count'] += 1
		_szm_opt['zombies_die'][_szm_opt['zombies_die']['count']] = argv1

		es.precachesound(argv1)
		if es.getargv(2):
			es.stringtable("downloadables","sound/%s" % (argv1))
	else:
		es.dbgmsg(0, "Syntax: szm_add_zombies_die_sound <soundfile.wav|mp3> <Download (0 = No | 1 = Yes)>")

def szm_add_zombie():
	if es.getargc() > 6:
		global _szm_opt
		_szm_opt['zombies']['menu_num_count'] += 1
		_szm_opt['zombies']['count'] += 1
		
		_szm_opt['zombies'][_szm_opt['zombies']['count']] = {}

		argv1 = es.getargv(1)
		_szm_opt['zombies'][_szm_opt['zombies']['count']]['Name'] = argv1
		_szm_opt['zombies']['menus'][_szm_opt['zombies']['menu_count']] += "->%s. %s" % (_szm_opt['zombies']['menu_num_count'], argv1)

		argv2 = es.getargv(2)
		if ".mdl" in argv2:
			argv2.replace(".mdl", "")

		_szm_opt['zombies'][_szm_opt['zombies']['count']]['Model'] = argv2
		es.precachemodel("models/%s.mdl" % (argv2))

		argv3 = es.getargv(3)
		_szm_opt['zombies'][_szm_opt['zombies']['count']]['Speed'] = argv3
		_szm_opt['zombies']['menus'][_szm_opt['zombies']['menu_count']] += " (%s Speed)" % (argv3)

		argv4 = es.getargv(4)
		_szm_opt['zombies'][_szm_opt['zombies']['count']]['Health'] = argv4
		_szm_opt['zombies']['menus'][_szm_opt['zombies']['menu_count']] += " (%s Health)" % (argv4)
		
		argv5 = es.getargv(5)
		_szm_opt['zombies'][_szm_opt['zombies']['count']]['AC'] = argv5
		if int(argv5):
			_szm_opt['zombies']['menus'][_szm_opt['zombies']['menu_count']] += " (AC)"
	
		argv6 = es.getargv(6)
		_szm_opt['zombies'][_szm_opt['zombies']['count']]['PJ'] = argv6
		if int(argv6):
			_szm_opt['zombies']['menus'][_szm_opt['zombies']['menu_count']] += " (PJ)"

		_szm_opt['zombies']['menus'][_szm_opt['zombies']['menu_count']] += "\n"
		if int(_szm_opt['zombies']['menu_num_count']) == 7:
			_szm_opt['zombies']['menu_num_count'] = 0
			_szm_opt['zombies']['menu_count'] += 1

			_szm_opt['zombies']['menus'][_szm_opt['zombies']['menu_count']] = "\n"
	else:
		es.dbgmsg(0, "Syntax: szm_add_zombie <\"Model Name\"> <\"Model File (.mdl)\"> <Speed> <Health> <Anti-Camp (0/1)> <Power-Jump (0/1)>")


def szm_add_human():
	if es.getargc() > 7:
		global _szm_opt
		_szm_opt['humans']['menu_num_count'] += 1
		_szm_opt['humans']['count'] += 1
		
		_szm_opt['humans'][_szm_opt['humans']['count']] = {}

		argv1 = es.getargv(1)
		_szm_opt['humans'][_szm_opt['humans']['count']]['Name'] = argv1
		_szm_opt['humans']['menus'][_szm_opt['humans']['menu_count']] += "->%s. %s" % (_szm_opt['humans']['menu_num_count'], argv1)

		argv2 = es.getargv(2)
		if ".mdl" in argv2:
			argv2.replace(".mdl", "")

		_szm_opt['humans'][_szm_opt['humans']['count']]['Model'] = argv2
		es.precachemodel("models/%s.mdl" % (argv2))

		argv3 = es.getargv(3)
		_szm_opt['humans'][_szm_opt['humans']['count']]['Speed'] = argv3
		_szm_opt['humans']['menus'][_szm_opt['humans']['menu_count']] += " (%s Speed)" % (argv3)

		argv4 = es.getargv(4)
		_szm_opt['humans'][_szm_opt['humans']['count']]['Health'] = argv4
		_szm_opt['humans']['menus'][_szm_opt['humans']['menu_count']] += " (%s Health)" % (argv4)
		
		argv5 = es.getargv(5)
		_szm_opt['humans'][_szm_opt['humans']['count']]['NV'] = argv5
		if int(argv5):
			_szm_opt['humans']['menus'][_szm_opt['humans']['menu_count']] += " (NV)"

		argv6 = es.getargv(6)
		_szm_opt['humans'][_szm_opt['humans']['count']]['AA'] = argv6
		if int(argv6):
			_szm_opt['humans']['menus'][_szm_opt['humans']['menu_count']] += " (AA)"

		argv7 = es.getargv(7)
		_szm_opt['humans'][_szm_opt['humans']['count']]['IHG'] = argv7
		if int(argv7):
			_szm_opt['humans']['menus'][_szm_opt['humans']['menu_count']] += " (IHG)"


		_szm_opt['humans']['menus'][_szm_opt['humans']['menu_count']] += "\n"
		if int(_szm_opt['humans']['menu_num_count']) == 7:
			_szm_opt['humans']['menu_num_count'] = 0
			_szm_opt['humans']['menu_count'] += 1

			_szm_opt['humans']['menus'][_szm_opt['humans']['menu_count']] = "\n"
	else:

		es.dbgmsg(0, "Syntax: szm_add_human <\"Model Name\"> <\"Model File (.mdl)\"> <Speed> <Health> <Nigth-Vision (0/1)> <Anti-Attract (0/1)> <Infinite HeGrenades (0/1)>")


def szm_add_crazy_zombies_msg():
	if es.getargc() > 1:
		global _szm_opt
		_szm_opt['crazy_zombies']['count'] += 1
		_szm_opt['crazy_zombies'][_szm_opt['crazy_zombies']['count']] = es.getargv(1)
	else:
		es.dbgmsg(0, "Syntax: szm_add_crazy_zombies_msg <\"Mensage\">")

def szm_add_zombies_emit_sound():
	if es.getargc() > 4:
		global _szm_opt
		_szm_opt['zombies_emit']['count'] += 1
		_szm_opt['zombies_emit'][_szm_opt['zombies_emit']['count']] = {}
		argv1 = es.getargv(1)
		_szm_opt['zombies_emit'][_szm_opt['zombies_emit']['count']]['sound'] = argv1
		_szm_opt['zombies_emit'][_szm_opt['zombies_emit']['count']]['attenuation'] = es.getargv(2)
		_szm_opt['zombies_emit'][_szm_opt['zombies_emit']['count']]['repeats'] = es.getargv(3)
		es.precachesound(argv1)
		if es.getargv(4):
			es.stringtable("downloadables","sound/%s" % (argv1))
	else:
		es.dbgmsg(0, "Syntax: szm_add_zombies_emit_sound <soundfile.wav|mp3> <Attenuation> <Repeats> <Download (0 = No | 1 = Yes)>")


def szm_jetpack_use_cmd():
	userid = es.getcmduserid()
	if int(szm_jetpack):
		player = playerlib.getPlayer(userid)
		if not player.attributes['isdead']:
			if int(es.getplayerteam(userid)) == 2:
				if int(szm_jetpack_t):
					es.emitsound("player", userid, "npc/manhack/mh_engine_loop2.wav", 1.0, 1.0)
					es.setplayerprop(userid, "CBaseEntity.movetype", '4')
				else:
					es.tell(userid, "\x04SZM:\x03 JetPack\x01 not allowed to be used in\x03 Ts\x01 Team!")
			else:
				if int(szm_jetpack_ct):
					es.emitsound("player", userid, "npc/manhack/mh_engine_loop2.wav", 1.0, 1.0)
					es.setplayerprop(userid, "CBaseEntity.movetype", '4')
				else:
					es.tell(userid, "\x04SZM:\x03 JetPack\x01 not allowed to be used in\x03 CTs\x01 Team!")
		else:
			es.tell(userid, "\x04SZM:\x03 JetPack\x01 Mod cant be used while you are\x03 Dead\x01!")
	else:
		es.tell(userid, "\x04SZM:\x01 JetPack\x01 Mod is\x03 Disable\x01!")

def szm_jetpack_unuse_cmd():
	userid = es.getcmduserid()
	es.setplayerprop(userid, "CBaseEntity.movetype", '2')
	es.stopsound(userid, "npc/manhack/mh_engine_loop2.wav")
	es.stopsound(userid, "npc/manhack/mh_engine_loop2.wav")
	#es.delayed 0.1 es_stopsound server_var(szm_cmds_temp) npc/manhack/mh_engine_loop2.wav
	#es_delayed 0.2 es_stopsound server_var(szm_cmds_temp) npc/manhack/mh_engine_loop2.wav

def szm_antistuck(userid):
	es.server.cmd("est_PhysPush %s %s %s %s" % (userid, random.randint(-1000, 1000), random.randint(-1000, 1000), random.randint(50, 1000)))


def szm_add_humans_props():
	if es.getargc() > 3:
		_szm_opt['PropsMenuCT']['menu_num_count'] += 1
		_szm_opt['PropsMenuCT']['count'] += 1
		
		_szm_opt['PropsMenuCT'][_szm_opt['PropsMenuCT']['count']] = {}

		argv1 = es.getargv(1)
		_szm_opt['PropsMenuCT'][_szm_opt['PropsMenuCT']['count']]['Name'] = argv1
		_szm_opt['PropsMenuCT']['menus'][_szm_opt['PropsMenuCT']['menu_count']] += "->%s. %s" % (_szm_opt['PropsMenuCT']['menu_num_count'], argv1)

		argv2 = es.getargv(2)
		if not ".mdl" in argv2:
			argv2 += ".mdl"
		_szm_opt['PropsMenuCT'][_szm_opt['PropsMenuCT']['count']]['Model'] = argv2

		argv3 = es.getargv(3)
		_szm_opt['PropsMenuCT'][_szm_opt['PropsMenuCT']['count']]['Costs'] = argv3
		_szm_opt['PropsMenuCT']['menus'][_szm_opt['PropsMenuCT']['menu_count']] += " (%s)" % (argv3)

		_szm_opt['PropsMenuCT']['menus'][_szm_opt['PropsMenuCT']['menu_count']] += "\n"

		if int(_szm_opt['PropsMenuCT']['menu_num_count']) == 7:
			_szm_opt['PropsMenuCT']['menu_num_count'] = 0
			_szm_opt['PropsMenuCT']['menu_count'] += 1

			_szm_opt['PropsMenuCT']['menus'][_szm_opt['PropsMenuCT']['menu_count']] = "\n"
	else:
		es.dbgmsg(0, "Syntax: szm_add_humans_props <Name> <model.mdl> <Costs>")

def szm_add_zombies_props():
	if es.getargc() > 3:
		_szm_opt['PropsMenuT']['menu_num_count'] += 1
		_szm_opt['PropsMenuT']['count'] += 1
		
		_szm_opt['PropsMenuT'][_szm_opt['PropsMenuT']['count']] = {}

		argv1 = es.getargv(1)
		_szm_opt['PropsMenuT'][_szm_opt['PropsMenuT']['count']]['Name'] = argv1
		_szm_opt['PropsMenuT']['menus'][_szm_opt['PropsMenuT']['menu_count']] += "->%s. %s" % (_szm_opt['PropsMenuT']['menu_num_count'], argv1)

		argv2 = es.getargv(2)
		if not ".mdl" in argv2:
			argv2 += ".mdl"
		_szm_opt['PropsMenuT'][_szm_opt['PropsMenuT']['count']]['Model'] = argv2

		argv3 = es.getargv(3)
		_szm_opt['PropsMenuT'][_szm_opt['PropsMenuT']['count']]['Costs'] = argv3
		_szm_opt['PropsMenuT']['menus'][_szm_opt['PropsMenuT']['menu_count']] += " (%s)" % (argv3)

		_szm_opt['PropsMenuT']['menus'][_szm_opt['PropsMenuT']['menu_count']] += "\n"

		if int(_szm_opt['PropsMenuT']['menu_num_count']) == 7:
			_szm_opt['PropsMenuT']['menu_num_count'] = 0
			_szm_opt['PropsMenuT']['menu_count'] += 1

			_szm_opt['PropsMenuT']['menus'][_szm_opt['PropsMenuT']['menu_count']] = "\n"
	else:
		es.dbgmsg(0, "Syntax: szm_add_zombies_props <Name> <model.mdl> <Costs>")


def szm_add_download_file():
	if es.getargc() > 1:
		argv1 = es.getargv(1)
		if os.path.isfile("%s/%s" % (es.ServerVar('eventscripts_gamedir'), argv1)):
			f = open("%s/%s" % (es.ServerVar('eventscripts_gamedir'), argv1))
			if f:
				lines = f.readlines()
				if not lines:
					return '0'

				for dl in lines:
					if len(dl) > 10 and dl[0:2] <> "//" and dl[0:1] <> "#":
						#es.msg("SZM: Added Download: %s" % (dl))
						#es.stringtable("downloadables", dl)
						es.server.cmd("downloadable %s" % (dl))
				f.close()			
			else:
				es.dbgmsg(0, "File '%s' not able to read!" % (argv1))
		else:
			es.dbgmsg(0, "File '%s' not exists!" % (argv1))
	else:
		es.dbgmsg(0, "Syntax: szm_add_download_file <file.ext>")

def szm_spawn_say(userid):
	if int(szm_deathmatch_mod):
		if int(szm_deathmatch_mod_force_respawn) and IsAlive.has_key(userid):
			team = es_getplayerteam(userid)
			if int(team) == 2:
				if not int(szm_deathmatch_mod_team_allow_respawn == 2):
					es.server.cmd("est_spawn %s" % (userid))
				else:
					es_tell(userid, "\x04SZM:\x01 You are not\x03 Allowed\x01 to repawn!")
			else:
				if not int(szm_deathmatch_mod_team_allow_respawn < 3):
					es.server.cmd("est_spawn %s" % (userid))
				else:
					es_tell(userid, "\x04SZM:\x01 You are not\x03 Allowed\x01 to repawn!")


def szm_nightvision_cmd():
	es.tell(es.getcmduserid(), "\x04SZM:\x01 NightVision usage is current\x03 Restricted\x01!")


#############################################################################################################################
         ##########################################       SZM Models           #######################################
#############################################################################################################################


def szm_models_menu(userid, type):
	global _szm_opt
	newmenu = None
	menu = None
	opt = "0123456789"
	
	if type == "zombie":
		menu = str(_szm_opt['zombies']['menus'][_szm_opt['userids'][userid]['models_menu']])	
		newmenu = "SZM v%s <-> By sn4k3\nChoose Your Zombie Caracter (%s/%s)\n %s\n0. Random (?)\n \n8. Back\n9. Next\n \n----------Powers----------\nAC = Anti-Camper  |  PJ = Power Jump" % (szm_version, _szm_opt['userids'][userid]['models_menu']+1, _szm_opt['zombies']['menu_num_count'], menu)

	elif type == "human":
		menu = _szm_opt['humans']['menus'][_szm_opt['userids'][userid]['models_menu']]
		newmenu = "SZM v%s <-> By sn4k3\nChoose Your Human Caracter (%s/%s)\n %s\n0. Random (?)\n \n8. Back\n9. Next\n \n----------------------\nNV = Nigth-Vision  |  AA = Anti-Attract\nIHG = Infinite HeGrenades" % (szm_version, _szm_opt['userids'][userid]['models_menu']+1, _szm_opt['humans']['menu_num_count'], menu)
	else:
		return '0'
	
	if not "->2." in menu:
		opt = opt.replace("2", "")
	if not "->3." in menu:
		opt = opt.replace("3", "")
	if not "->4." in menu:
		opt = opt.replace("4", "")
	if not "->5." in menu:
		opt = opt.replace("5", "")
	if not "->6." in menu:
		opt = opt.replace("6", "")
	if not "->7." in menu:
		opt = opt.replace("7", "")
	es.menu(0, userid, newmenu, opt)
	_szm_opt['handlemenu'][userid] = 1

def szm_zombies_handlemenu(userid, commandstring):
	global _szm_opt
	_szm_opt['handlemenu'][userid] = 0
	if commandstring in "1234567":
		menu = _szm_opt['zombies']['menus'][_szm_opt['userids'][userid]['models_menu']]
		if not _szm_opt['userids'][userid].has_key("model_t"):
			_szm_opt['userids'][userid]['model_t'] = int(_szm_opt['userids'][userid]['models_menu']) * 7 + int(commandstring)
			szm_give_models(userid, "zombie")
		else:
			_szm_opt['userids'][userid]['model_t'] = int(_szm_opt['userids'][userid]['models_menu']) * 7 + int(commandstring)
			es.tell(userid, "\x04SZM:\x01 You will re-spawn with a new\x03 Zombie\x01 Model!")
		es.playsound(userid, "buttons/button24.wav", 1.0)
	elif int(commandstring) == 8 or int(commandstring) == 9:
		i = _szm_opt['userids'][userid]['models_menu']
		if int(commandstring) == 8:
			i -= 1
		else:
			i += 1
			
		if _szm_opt['zombies']['menus'].has_key(i):
			menu = _szm_opt['zombies']['menus'][i]
			if "->1." in menu:
				_szm_opt['userids'][userid]['models_menu'] = i
				es.playsound(userid, "buttons/button24.wav", 1.0)
			else:
				es.playsound(userid, "buttons/combine_button7.wav", 1.0)
		szm_models_menu(userid, "zombie")
	elif int(commandstring) == 10:
		szm_autorand_model(userid, "zombie")
		es.playsound(userid, "buttons/button24.wav", 1.0)
		
def szm_humans_handlemenu(userid, commandstring):
	global _szm_opt
	_szm_opt['handlemenu'][userid] = 0
	if commandstring in "1234567":
		menu = _szm_opt['humans']['menus'][_szm_opt['userids'][userid]['models_menu']]
		if not _szm_opt['userids'][userid].has_key("model_ct"):
			_szm_opt['userids'][userid]['model_ct'] = int(_szm_opt['userids'][userid]['models_menu']) * 7 + int(commandstring)
			szm_give_models(userid, "human")
		else:
			_szm_opt['userids'][userid]['model_ct'] = int(_szm_opt['userids'][userid]['models_menu']) * 7 + int(commandstring)
			es.tell(userid, "\x04SZM:\x01 You will re-spawn with a new\x03 Human\x01 Model!")
		es.playsound(userid, "buttons/button24.wav", 1.0)
	elif int(commandstring) == 8 or int(commandstring) == 9:
		i = _szm_opt['userids'][userid]['models_menu']
		if int(commandstring) == 8:
			i -= 1
		else:
			i += 1
			
		if _szm_opt['humans']['menus'].has_key(i):
			menu = _szm_opt['humans']['menus'][i]
			if "->1." in menu:
				_szm_opt['userids'][userid]['models_menu'] = i
				es.playsound(userid, "buttons/button24.wav", 1.0)
			else:
				es.playsound(userid, "buttons/combine_button7.wav", 1.0)
		szm_models_menu(userid, "human")
	elif int(commandstring) == 10:
		szm_autorand_model(userid, "human")
		es.playsound(userid, "buttons/button24.wav", 1.0)

def szm_autorand_model(userid, type):
	if type == "zombie":
		if not _szm_opt['userids'][userid].has_key("model_t"):
			_szm_opt['userids'][userid]['model_t'] = random.randint(1, int(_szm_opt['zombies']['count']))
			szm_give_models(userid, "zombie")
		else:
			es.tell(userid, "\x04SZM:\x01 You will re-spawn with a new\x03 Zombie\x01 Model!")
			_szm_opt['userids'][userid]['model_t'] = random.randint(1, int(_szm_opt['zombies']['count']))
	elif type == "human":
		if not _szm_opt['userids'][userid].has_key("model_ct"):
			_szm_opt['userids'][userid]['model_ct'] = random.randint(1, int(_szm_opt['humans']['count']))
			szm_give_models(userid, "human")
		else:
			es.tell(userid, "\x04SZM:\x01 You will re-spawn with a new\x03 Human\x01 Model!")
			_szm_opt['userids'][userid]['model_ct'] = random.randint(1, int(_szm_opt['humans']['count']))

def szm_give_models(userid, type):
	player = playerlib.getPlayer(userid)
	if not player.attributes['isdead']:
		if type == "zombie":
			es.server.cmd("est_SetModel %s %s" % (userid, _szm_opt['zombies'][_szm_opt['userids'][userid]['model_t']]['Model']))	

			if int(szm_crazy_zombies_mod):
				i = int(_szm_opt['data']['crazy_zombies_mod_current_level']) * float(szm_crazy_zombies_mod_speed_to_add) 
				i += float(_szm_opt['zombies'][_szm_opt['userids'][userid]['model_t']]['Speed'])

				es.setplayerprop(userid, "CBasePlayer.localdata.m_flLaggedMovementValue", i)
				i = int(_szm_opt['data']['crazy_zombies_mod_current_level']) * int(szm_crazy_zombies_mod_health_to_add)
				i += int(_szm_opt['zombies'][_szm_opt['userids'][userid]['model_t']]['Health'])
				es.setplayerprop(userid, "CBasePlayer.m_iHealth", i)
			else:
				es.setplayerprop(userid, "CBasePlayer.localdata.m_flLaggedMovementValue", _szm_opt['zombies'][_szm_opt['userids'][userid]['model_t']]['Speed'])
				es.setplayerprop(userid, "CBasePlayer.m_iHealth", _szm_opt['zombies'][_szm_opt['userids'][userid]['model_t']]['Health'])

			if _szm_opt['zombies'][_szm_opt['userids'][userid]['model_t']]['AC']:
				es.setplayerprop(userid, "CCSPlayer.baseclass.localdata.m_Local.m_flStepSize", 99)

			es.server.cmd("est_StripPlayer %s;es_give %s item_nvgs;es_give %s weapon_knife" % (userid, userid, userid))
			es.setplayerprop(userid, "CCSPlayer.m_bNightVisionOn", 1)

			es.setplayerprop(userid, "CCSPlayer.baseclass.m_iFOV", random.randint(120, 165))
		elif type == "human":
			es.server.cmd("est_SetModel %s %s" % (userid, _szm_opt['humans'][_szm_opt['userids'][userid]['model_ct']]['Model']))
			es.setplayerprop(userid, "CBasePlayer.localdata.m_flLaggedMovementValue", _szm_opt['humans'][_szm_opt['userids'][userid]['model_ct']]['Speed'])
			es.setplayerprop(userid, "CBasePlayer.m_iHealth", _szm_opt['humans'][_szm_opt['userids'][userid]['model_ct']]['Health'])
			if int(_szm_opt['humans'][_szm_opt['userids'][userid]['model_ct']]['NV']):
				es.server.cmd("es_give %s item_nvgs" % (userid))
				es.setplayerprop(userid, "CCSPlayer.m_bNightVisionOn", 1)
			if int(_szm_opt['humans'][_szm_opt['userids'][userid]['model_ct']]['IHG']):
				es.server.cmd("es_give %s weapon_hegrenade" % (userid))
				if not int(szm_infinite_he_type):
					es.server.cmd("est_SetAmmo %s hegrenade 1000" % (userid))
	
#############################################################################################################################
         ##########################################       SZM Shops           #######################################
#############################################################################################################################
					
def szm_shop_props_menu(userid, type):
	global _szm_opt
	newmenu = None
	menu = None
	opt = "0123456789"
	
	_szm_tempuserid.set(0)
	es.server.cmd("est_GetKills _szm_tempuserid %s" % (userid))
	
	if type == "zombie":
		menu = _szm_opt['PropsMenuT']['menus'][_szm_opt['userids'][userid]['shopprops_menu']]
		newmenu = "SZM v%s <-> By sn4k3\nWhat item you want spawn? (%s/%s)\nCurrent Points: %s\n %s\n \n8. Back\n9. Next\n0. Cancel" % (szm_version, _szm_opt['userids'][userid]['shopprops_menu']+1, _szm_opt['PropsMenuT']['menu_num_count'], _szm_tempuserid, menu)
	elif type == "human":
		menu = _szm_opt['PropsMenuCT']['menus'][_szm_opt['userids'][userid]['shopprops_menu']]
		newmenu = "SZM v%s <-> By sn4k3\nWhat item you want spawn? (%s/%s)\nCurrent Points: %s\n %s\n \n8. Back\n9. Next\n0. Cancel" % (szm_version, _szm_opt['userids'][userid]['shopprops_menu']+1, _szm_opt['PropsMenuCT']['menu_num_count'], _szm_tempuserid, menu)
	else:
		return '0'
			
	if not "->2." in menu:
		opt = opt.replace("2", "")
	if not "->3." in menu:
		opt = opt.replace("3", "")
	if not "->4." in menu:
		opt = opt.replace("4", "")
	if not "->5." in menu:
		opt = opt.replace("5", "")
	if not "->6." in menu:
		opt = opt.replace("6", "")
	if not "->7." in menu:
		opt = opt.replace("7", "")
	es.menu(0, userid, newmenu, opt)
	_szm_opt['handlemenu'][userid] = 2
	
def szm_shop_humans_props_handlemenu(userid, commandstring):
	global _szm_opt
	_szm_opt['handlemenu'][userid] = 0
	if commandstring in "1234567":
		prop = int(_szm_opt['userids'][userid]['shopprops_menu']) * 7 + int(commandstring)
		szm_shop_props_buy(userid, prop, "human")
	elif int(commandstring) == 8 or int(commandstring) == 9:
		i = _szm_opt['userids'][userid]['shopprops_menu']
		if int(commandstring) == 8:
			i -= 1
		else:
			i += 1
			
		if _szm_opt['PropsMenuCT']['menus'].has_key(i):
			menu = _szm_opt['PropsMenuCT']['menus'][i]
			if "->1." in menu:
				_szm_opt['userids'][userid]['shopprops_menu'] = i
				es.playsound(userid, "buttons/button24.wav", 1.0)
			else:
				es.playsound(userid, "buttons/combine_button7.wav", 1.0)
		szm_shop_props_menu(userid, "human")
	elif int(commandstring) == 10:
		es.playsound(userid, "buttons/combine_button7.wav", 1.0)
		
def szm_shop_zombies_props_handlemenu(userid, commandstring):
	global _szm_opt
	_szm_opt['handlemenu'][userid] = 0
	if commandstring in "1234567":
		prop = int(_szm_opt['userids'][userid]['shopprops_menu']) * 7 + int(commandstring)
		szm_shop_props_buy(userid, prop, "zombie")
	elif int(commandstring) == 8 or int(commandstring) == 9:
		i = _szm_opt['userids'][userid]['shopprops_menu']
		if int(commandstring) == 8:
			i -= 1
		else:
			i += 1
			
		if _szm_opt['PropsMenuT']['menus'].has_key(i):
			menu = _szm_opt['PropsMenuT']['menus'][i]
			if "->1." in menu:
				_szm_opt['userids'][userid]['shopprops_menu'] = i
				es.playsound(userid, "buttons/button24.wav", 1.0)
			else:
				es.playsound(userid, "buttons/combine_button7.wav", 1.0)
		szm_shop_props_menu(userid, "zombie")
	elif int(commandstring) == 10:
		es.playsound(userid, "buttons/combine_button7.wav", 1.0)


def szm_shop_props_buy(userid, prop, type):
	_szm_tempuserid.set(0)
	es.server.cmd("est_GetKills _szm_tempuserid %s" % (userid))
	if type == "human":
		if int(_szm_tempuserid) >= int(_szm_opt['PropsMenuCT'][prop]['Costs']):
			player = playerlib.getPlayer(userid)
			if not player.attributes['isdead']:
				kills = int(_szm_tempuserid) - int(_szm_opt['PropsMenuCT'][prop]['Costs'])
				es.server.queuecmd("est_KillSet %s %s;es_prop_physics_create %s %s;est_HSay %s SZM Shop:\\nYour buy: %s\\nCosts In Kills: %s\\nRemaining Kills: %s" % (userid, kills, userid, _szm_opt['PropsMenuCT'][prop]['Model'], userid, _szm_opt['PropsMenuCT'][prop]['Name'], _szm_opt['PropsMenuCT'][prop]['Costs'], kills))	
				es.playsound(userid, "buttons/button24.wav", 1.0)
		else:
			es.tell(userid, "\x04SZM:\x01 You not have\x03 %s\x01 Kill(s)!" % (_szm_opt['PropsMenuCT'][prop]['Costs']))
			es.playsound(userid, "buttons/combine_button7.wav", 1.0)
	elif type == "zombie":
		if int(_szm_tempuserid) >= int(_szm_opt['PropsMenuT'][prop]['Costs']):
			player = playerlib.getPlayer(userid)
			if not player.attributes['isdead']:
				kills = int(_szm_tempuserid) - int(_szm_opt['PropsMenuT'][prop]['Costs'])
				es.server.queuecmd("est_KillSet %s %s;es_prop_physics_create %s %s;est_HSay %s SZM Shop:\\nYour buy: %s\\nCosts In Kills: %s\\nRemaining Kills: %s" % (userid, kills, userid, _szm_opt['PropsMenuT'][prop]['Model'], userid, _szm_opt['PropsMenuT'][prop]['Name'], _szm_opt['PropsMenuT'][prop]['Costs'], kills))	
				es.playsound(userid, "buttons/button24.wav", 1.0)
		else:
			es.tell(userid, "\x04SZM:\x01 You not have\x03 %s\x01 Kill(s)!" % (_szm_opt['PropsMenuT'][prop]['Costs']))
			es.playsound(userid, "buttons/combine_button7.wav", 1.0)
	else:
		return '0'

	szm_shop_props_menu(userid, type)